'	 :
'	3-          -  
'	2-          -   
'	1-       -     
'****************************************************************************************************************
'	priorities:
'	3-running the script without a parameter and with an empty line in the header - a dialog is called
'	2-Running the script without a parameter and specifying the file in the header - processes the specified file
'	1-Launch with the file name specified in the parameter - processes the file specified in the parameter
'**************************************************************
'* by Dmitriy Demin Moskow v3.02 09.2022       RuBIOS@mail.ru *
'**************************************************************
Dim wsh, put, bit(8)
'On Error Resume Next
'====================================================================================
'***********   Presets variables   ***************
'====================================================================================
PathCoder   = "D:\OrDebuggerUSB\TASM\tasm.exe"          '!!! Full path necessary !!!
ParamCoder  = " -85 -b "                            'Parameters
'---------
PathEmul    = "D:\OrDebuggerUSB\OrionZEmu\OrionZEm.exe"	'!!! Full path necessary !!!
'---------
FileAsm     = "my.asm"                       '!!! SPECIFY YOUR FILE !!!
'FileAsm   	= ""                                     'uncomment to open a file dialog
'---------
ComSet      = "COM5:9800,N,8,1"                    'Parameters COM port
'---------
CorrByte    = &H00        'adding bytes that are multiples of 16 to a file
'=====================================================================================
'*****   parameters of the BRU header   **********
'=====================================================================================
StartAdr = &H0100           'Download address
BruHeadName = "TEST$   "    'set filename in the header BRU  == 8 BYTES. if < 8 add spaces
Atr1 =	&H00
Atr2 =	0
Atr3 =	0
Atr4 =	&H0FF

'************  Atr3 **************** 
bit(0) = 0 '      : 1 - ; 0 - 
bit(1) = 1 '   
bit(2) = 1 '  
bit(3) = 1 '   : 1-; 0-
bit(4) = 1 '    : 1 -  ; 0 -   F800
'---------------
Atr3 = bits
'MsgBox Hex(Atr3)
'=======================================================================================
'*******   Flags   ********************
'=======================================================================================
'NotepadFlag  = 1    'Set = 1 - Open notepad after compilation with the *.lst file
EmulFlag     = 1    'Set = 1 - Launching the Orion Emulator
'SendCOMflag  = 1    'Set = 1 - Send Bru file to > COM port
FileCorrect16 = 1    'Set = 1 - dding bytes in multiples of 16 to a file
'GetHeadName   = 1
'**********************************

'**********************************************************
Set fso=CreateObject("Scripting.FileSystemObject")
if fso.FileExists(FileAsm) = False Then FileAsm = "" '  

'************* file selection method *************************************
If WScript.Arguments.Count <> 1 Then '
	if FileAsm = "" Then
		FileAsm = FlName(SelectFile)
	end if
else
FileAsm = FlName(WScript.Arguments(0))
End If

'***********************************************************
if GetHeadName = 1 Then
BruHeadName = BaseName(FileAsm)
End if

if Len(BruHeadName) <> 8 Then
MsgBox "ERROR! HEAD NAME <> 8"
Wscript.Quit
End if
'********** preparation variables ************************
PathProject	= CurrentPath
FileBin 	= PathProject&"\"&BaseName(FileAsm)&".bin"
FileLst 	= PathProject&"\"&BaseName(FileAsm)&".lst"
FileBru		= PathProject&"\"&BaseName(FileAsm)&".bru"

'############# send bru #########################
if ExtName(UCase(FileAsm)) = "BRU" Then  '###
'********** Sending to COM port ******************
if SendCOMflag = 1 then
	fbin=readBinary(FileBru)
'MsgBox Len(fbin)
	COMPort_Write(fbin)
End if
'********** Sending to emulator ******************
if EmulFlag = 1 then
	Set wsh = WScript.CreateObject("WScript.Shell")
	Set fso=CreateObject("Scripting.FileSystemObject")
	Fso.CopyFile FileBRU , FlPath(PathEmul)&"\tmp.bru" , True	'copy temporary file BRU to folder emulator
	wsh.CurrentDirectory = FlPath(PathEmul)
	wsh.run(PathEmul&" tmp.bru")								'startihg emulator
End if
Wscript.Quit
End if
'######################################
'******* Starting compiler ********************** 
Set wsh = WScript.CreateObject("WScript.Shell")
wsh.CurrentDirectory = FlPath(PathCoder)
wsh.Run(""""&PathCoder&""" "&ParamCoder&" "&PathProject&"\"&FileAsm&" "&FileBin&" "&FileLst)
WScript.Sleep 500
wsh.CurrentDirectory = FlPath(PathProject)

'***** notepad open ****************
if NotepadFlag = 1 then
	wsh.Run("notepad.exe "&FileLst)
end if

'********** Read bin file ******************
fbin = readBinary(FileBin)
if FileCorrect16 = 1 then
  fbin16 = Correct16(FileBin)
  fbin = fbin&fbin16
End if

'********* Get file size ************************
'FSize = FileSize(FileBin)
FSize = Len(Fbin)

'==========================================================
'********** Creating and adding a header BRU file ******************
Set Fout = fso.OpenTextFile(FileBru,2,1,0) 'OpenTextFile (File, [ iomode, [ create, [ format ]]])
Fout.Write BruHeadName+HexD(StartAdr)+HexD(FSize)+Chr(Atr1)+Chr(Atr2)+Chr(Atr3)+Chr(Atr4)+fbin
Fout.Close

'********** Sending to COM port ******************
if SendCOMflag = 1 then
	fbin=readBinary(FileBru)
	COMPort_Write(fbin)
End if

'********** Sending to emulator ******************
if EmulFlag = 1 then
	Set fso=CreateObject("Scripting.FileSystemObject")
	Fso.CopyFile FileBRU , FlPath(PathEmul)&"\tmp.bru" , True	'copy temporary file BRU to folder emulator
	wsh.CurrentDirectory = FlPath(PathEmul)
	wsh.run(PathEmul&" tmp.bru")								'startihg emulator
End if

Wscript.Quit

'############### Functions #######################################################

'***************** Open select file dialog **********************
Function SelectFile()
   strMSHTA = "mshta.exe ""about:<input type=file id=FILE>"_
	& "<script>FILE.click();"_
	& "new ActiveXObject('Scripting.FileSystemObject')"_
	& ".GetStandardStream(1).WriteLine(FILE.value);"_
	& "close();resizeTo(0,0);"_
	& "</script>"""
   Set wshShell = CreateObject("WScript.Shell")
   Set objExec = wshShell.Exec(strMSHTA)
   SelectFile = objExec.StdOut.ReadLine()
   Set objExec = Nothing
   Set wshShell = Nothing
End Function

'=========== File size =================
Function FileSize(File)
 Set fso=CreateObject("Scripting.FileSystemObject")
 Set fs = fso.GetFile(File)	' 
 FileSize = fs.Size					' FSize = bin file
End Function

'********** Return name only - path\(NAME).ext *********
Function BaseName(FullPath)
	Set fso=CreateObject("Scripting.FileSystemObject")
	BaseName = FSO.GetBaseName(FullPath)
End Function
'*********** Return extencion only - path\name.(EXT) ******************
Function ExtName(FullPath)
	Set fso=CreateObject("Scripting.FileSystemObject")
	ExtName = FSO.GetExtensionName(FullPath)
End Function
'*********** path\(NAME.EXT) *************
Function FlName(FullPath)
	Set fso=CreateObject("Scripting.FileSystemObject")
	FlName = FSO.GetFileName(FullPath)
End Function
'******** Return path only - (PATH)\name.ext ****************************
Function FlPath(FullPath)
	FlPath = Mid(FullPath,1,InStrRev(FullPath,"\")-1)
End Function
'******** Current path project script folder ****************************
Function CurrentPath()
	CurrentPath = Mid(WScript.ScriptFullName,1,InStrRev(WScript.ScriptFullName,"\")-1)
End Function

'****************** Convert 0-65535 -> 0000-FFFF *********************
Function HexD(Dec)
if Dec > 255 Then
	HAdr= Dec \ 256
	LAdr= Dec - (HAdr * 256)
Else
	HAdr= 0
	LAdr= Dec
end if
HexD = Chr(LAdr)&Chr(HAdr)
End Function

'=========== Correction BRU multiple of 16 for ROM disk ==================
Function Correct16(File)
S1= FileSize(File)
	Add = 16 - (S1-(S1\16)*16)
For i = 1 To Add
	Correct16 = Correct16 + Chr(CorrByte)
Next
End Function

'****************************************************
Function readBinary(file)
    Dim oFSO: Set oFSO = CreateObject("Scripting.FileSystemObject")
    Dim oFile: Set oFile = oFSO.GetFile(file)
    Dim binFile: Set binFile = oFile.OpenAsTextStream()
    readBinary = binFile.Read(oFile.Size)
    binFile.Close
End Function
'***************************************************
Sub writeBinary(file, data)
    Dim oFSO: Set oFSO = CreateObject("Scripting.FileSystemObject")
    Dim binFile: Set binFile = oFSO.CreateTextFile(file)
    binFile.Write(data)
    binFile.Close
End Sub
'***************************************************
Function readBinaryFromPos(file, pos, size_byte)
	If size_byte = 0 Then Exit Function
	Dim oFSO: Set oFSO = CreateObject("Scripting.FileSystemObject")
	Dim oFile: Set oFile = oFSO.GetFile(file)
	Dim binFile: Set binFile = oFile.OpenAsTextStream()
	Dim data_skip: data_skip = binFile.Read(pos)
    readBinaryFromPos = binFile.Read(size_byte)
    binFile.Close
End Function
'***************************************************
Sub writeBinaryToPos(file, data, pos)
    Dim oFSO: Set oFSO = CreateObject("Scripting.FileSystemObject")
    Dim oFile: Set oFile = oFSO.GetFile(file)
    Dim binFile: Set binFile = oFile.OpenAsTextStream()
    Dim data_p1: data_p1 = binFile.Read(pos) '  1 -   data
    Dim data_skip: data_skip = binFile.Read(Len(data)) '   data ( )
    Dim data_p2: data_p2 = binFile.Read(oFile.Size) '  2 -   data
    binFile.Close
    Set binFile = oFile.OpenAsTextStream(ForWriting)
    binFile.Write(data_p1) '   1
    binFile.Write(data) '   
    binFile.Write(data_p2) '   2
    binFile.Close
End Sub
'******************************************************
Function getHexData(str_hex)
    If (str_hex = "") Then getHexData = -1: Exit Function '     
    str_hex = Replace(str_hex, " ", "") '   
    If (Len(str_hex) Mod 2 = 1) Then getHexData = -1: Exit Function '   2 (.. 2  = 1 )
 
    Dim i, ch, ch1, ch2
    Dim hex_chr: hex_chr = "0123456789ABCDEF"
    
    getHexData = ""
    For i = 1 To Len(str_hex) Step 2
        ch1 = Mid(str_hex, i, 1) ' 1-  
        ch2 = Mid(str_hex, i+1, 1) ' 2-  
        '     hex 
        If (InStr(1, hex_chr, ch1, vbTextCompare) = 0 OR InStr(1, hex_chr, ch2, vbTextCompare) = 0) Then getHexData = -1: Exit Function
        ch = "&h" & ch1 & ch2 '   hex     &h...
        getHexData = getHexData & Chr(ch)
    Next
End Function
'*****************************************************
Function bits()
for i=0 to 7
 if bit(i) = 1 then
  bits = bits or(2 ^ i) 
 Else
  bits = bits And Not(2 ^ i) 
 End if
Next
End Function
'*********** Send COM port *********************************************
Function COMPort_Write(put)
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set objCOM = objFSO.OpenTextFile(ComSet,2,1,0)

	objCOM.Write put
	WScript.Sleep 300

	If Err.Number <> 0 Then
		MsgBox "ERROR COM"
	End if

	objCOM.Close
End Function

























