#define ORG .org
#define EQU .equ
#define DB  .db
#define DW  .dw


RESET	EQU 0F800H	;ВЫХОД В МОНИТОР
KBRD	EQU 0F803H	;ВВОД C СИМВОЛА С КЛАВИАТУРЫ С ОЖИДАНИЕМ ВЫХ: А — ВВЕДЕННЫЙ СИМВОЛ
TAPI	EQU 0F806H	;ВВОД БАЙТА С МАГНИТОФОНА.    ВХ.: А=0FFH — С ПОИСКОМ СИНХРОБАИТА; А=08Н — БЕЗ ПОИСКА
;KBDCTL	EQU 0F806H	;УПРАВЛЕНИЕ КЛАВИАТУРОЙ.
TVC		EQU 0F809H	;ВЫВОД СИМВОЛА НА ЭКРАН.      ВХ.: С — ВЫВОДИМЫЙ СИМВОЛ
TAPO	EQU 0F80CH	;ЗАПИСЬ БАЙТА НА МАГНИТОФОН.  ВХ.: С — ЗАПИСЫВАЕМЫЙ БАЙТ
SCRCTL	EQU 0F80CH	;УПРАВЛЕНИЕ ЭКРАНОМ
TV		EQU 0F80FH	;ВЫВОД СИМВОЛА НА ЭКРАН.      ВХ.: А — ВЫВОДИМЫЙ СИМВОЛ (все регистры сохраняются)
STTS	EQU 0F812H	;ОПРОС СОСТОЯНИЯ КЛАВИАТУРЫ.  ВЫХ.: А=00Н — НЕ НАЖАТА; А=0FFH — НАЖАТА
HEX		EQU 0F815H	;ВЫВОД БАЙТА НА ЭКРАН В НЕХ-КОДЕ ВХ.: А — ВЫВОДИМЫЙ СИМВОЛ
MSG		EQU 0F818H	;ВЫВОД НА ЭКРАН СООБЩЕНИЯ.    ВХ.: HL-АДРЕС НАЧАЛА; КОНЕЧНЫЙ БАЙТ — 00Н
INKEY	EQU 0F81BH	;ВВОД КОДА НАЖАТОЙ КЛАВИШИ.   ВЫХ: А=0FFH — НЕ НАЖАТА; А=0FEH — РУС/ЛАТ ИНАЧЕ — КОД КЛАВИШИ
RCUR	EQU 0F81EH	;ЗАПРОС ПОЛОЖЕНИЯ КУРСОРА.    ВЫХ: Н — НОМЕР СТРОКИ — Y; L — НОМЕР ПОЗИЦИИ — X
PRINT	EQU 0F821H	;ВЫВОД НА ПЕЧАТЬ
TAPIM	EQU 0F824H	;ЧТЕНИЕ ФАЙЛА ИЗ МАГ. ЛЕНТЫ. МАССИВ РАЗМЕШ.ПО АДРЕСАМ ЗАП. НА МАГНИТНОЙ ЛЕНТЕ
;NUMKEY	EQU 0F824H	;ОПРОС НОМЕРОВ НАЖАТЫХ КЛАВИШ
TAPOM	EQU 0F827H	;ЗАПИСЬ ФАЙЛА НА МАГ. ЛЕНТУ.  ВХ.: HL- НАЧ. АДРЕС МАССИВА в DE- КОНЕЧ. АДРЕС
;INFAST	EQU 0F827H	;БЫСТРЫЙ ОПРОС КЛАВИШ КУРСОРА, СПЕЦКЛАВИШ
TAPCM	EQU 0F82AH	;ПОДСЧЕТ КОНТРОЛЬНОЙ СУММЫ БЛОКА. ВХ.: HL — АДРЕС НАЧАЛА Е DE — АДРЕС КОНЦА; ВЫХ:ВС — КОНТРОЛЬНАЯ СУММА
;GRAPH	EQU 0F82AH	;ВЫВОД ГРАФИКИ
WGEN	EQU 0F82DH	;РАСПАКОВКА ВНУТРЕННЕГО ЗНАКОГЕНЕРАТОРА.
;MEMORY	EQU 0F82DH	;СИСТЕМА ДИНАМИЧЕСКОГО РАСПРЕДЕЛЕНИЯ ОЗУ.
RAMEND	EQU 0F830H	;ЧТЕНИЕ КОНЕЧНОГО АДРЕСА ОЗУ ПОЛЬЗОВАТ. ВЫХ: HL -КОНЕЧНЫЙ АДРЕС
;FILL	EQU 0F830H	;ЗАПОЛНЕНИЕ СТРАНИЦЫ ОЗУ КОНСТАНТОЙ. В регистре A указывается номер страницы ОЗУ, в регистре C записываемый байт, в регистрах HL - начальный адрес ОЗУ, DE - длина заполняемой области.
RAMWEND	EQU 0F833H	;ЗАПИСЬ КОНЕЧНОГО АДРЕСА ОЗУ ПОЛЬЗОВАТ. ВХ: HL -КОНЕЧНЫЙ АДРЕС
;MOVBL	EQU 0F833H	;ПЕРЕНОС БЛОКА КОДОВ. копирует блок данных из одной страницы памяти в другую. В регистре A указываются номера обеих страниц (старшие 4 разряда - "откуда", младшие - "куда"), в регистрах HL - начальный адрес "откуда", DE начальный адрес "куда", BC - число копируемых байт.
RBF		EQU 0F836H	;ЧТЕНИЕ БАЙТА ИЗ ДОП. СТРАН. BX.: HL-АДРЕСА — N СТРАНИЦЫ (0-3); ВЫХ: С — СЧИТАННЫЙ БАЙТ
;RRAM	EQU 0F836H	;ЧТЕНИЕ БАЙТА ИЗ ДОП. СТРАН. BX.: HL-АДРЕСА; A — N СТРАНИЦЫ (0-3); ВЫХ: С — СЧИТАННЫЙ БАЙТ
SBF		EQU 0F839H	;ЗАПИСЬ БАЙТА В ДОП. СТРАНИЦУ. BX.: HL — АДРЕСА — N СТРАНИЦЫ (0-3); C — ЗАПИСЫВАЕМЫЙ БАЙТ
;WRAM	EQU 0F839H	;ЗАПИСЬ БАЙТА В ДОП. СТРАНИЦУ. BX.: HL — АДРЕСА — N СТРАНИЦЫ (0-3); C — ЗАПИСЫВАЕМЫЙ БАЙТ
WCUR	EQU 0F83CH	;УСТАНОВКА ПОЗИЦИИ КУРСОРА  ВХ. Н — НОМЕР СТРОКИ — Y; L — НОМЕР ПОЗИЦИИ — X
SOUND	EQU 0F83FH	;СИНТЕЗ ЗВУКА

RDWIN	EQU 0F842H	;ЧТЕНИЕ ПОРТОВ ДИСПЕТЧЕРА В ОЗУ
WRWIN	EQU 0F845H	;ВОССТАНОВЛЕНИЕ ПОРТОВ ДИСПЕЧЕРА ИЗ ОЗУ
JPWIN	EQU 0F848H	;УСТАНОВКА ВАРИАНТА ДИСПЕТЧЕРА И ПЕРЕХОД
OPCLW	EQU 0F84BH	;ОТКРЫТЬ/ЗАКРЫТЬ ОКНО ОЗУ, ПЗУ
MOUSE	EQU 0F84EH	;ОПРОС ПОРТА МЫШИ
MSCTL	EQU 0F851H	;УПРАВЛЕНИЕ МЫШЬЮ
RDSEC	EQU 0F854H	;ЧТЕНИЕ СЕКТОРА С ДИСКА
WRSEC	EQU 0F857H	;ЗАПИСЬ СЕКТОРА НА ДИСК
SYSCTR	EQU 0F85AH	;УПРАВЛЕНИЕ СИСТЕМОЙ
VERS	EQU 0F85DH	;ПОЛУЧЕНИЕ НОМЕРА ВЕРСИИ ROM1/ROM2
KBSND	EQU 0F860H	;ФОРМИРОВАНИЕ ЗВУКА ПРИ НАЖАТИИ КЛАВИШИ
KBSIG	EQU 0F863H	;СИГНАЛИЗАЦИЯ ПЕРЕКЛЮЧЕНИЯ ФЛАГОВ КЛАВИАТУРЫ



CLSF0  EQU 0F300H
CLSI   EQU 0F303H
SBFF   EQU 0F306H
COLOR  EQU 0F319H
LOADF3 EQU 0F33AH

;WGEN	EQU 0F3D1H	;начальный адрес знакогенератора. По умолчанию — 0F000H
;		EQU 0F3D3H	;признак прямого (00Н) вывода (светлые символы на темном фоне) или инверсного (0FFH) вывода (темные символы на светлом фоне).
;MNJMP	EQU 0F3D8H	;ячейка, содержащая адрес возврата из подпрограммы чтения байта (OF806H) при «зависании» или выпадании сигнала. 
;МОНИТОР заносит в эту ячейку адрес «теплого старта». Программа пользователя должна заносить в эту ячейку свой адрес возврата, в противном случае при невозможности чтения байта программа осуществит возврат в МОНИТОР.
;
TIM50  EQU 0F3DAH	;ячейка, в которой хранится константа записи на магнитную ленту. Для скорости 1200 бод. Она имеет значение 40Н.
TIM75  EQU 0F3DBH	;ячейка, хранящая константу чтения с магнитной ленты. Для стандартной скорости — 60Н.
FLMN   EQU 0F3DCH

MXDSK  EQU 0BFD8H
ADRP   EQU 0BFBEH
DIRM   EQU 0BFE8H
RMX    EQU 0BFC1H
WMX    EQU 0BFC4H
ATFLD  EQU 0BFCDH
ATFLM  EQU 0BFC7H
RDISK  EQU 0BFDCH
WDISK  EQU 0BFDFH
PSCF   EQU 0BFE5H
SDMA   EQU 0BFD0H
LDMA   EQU 0BFD3H
WND0   EQU 0BFD6H
RND    EQU 0BFD9H
WTFLD  EQU 0BFCAH
WFILE  EQU 0BFF7H
RFILE  EQU 0BFFAH
DEL    EQU 0BFEEH
RENAME EQU 0BFEBH
DOS    EQU 0BFFDH
STACK  EQU 0F3C0H
